from parser import Parser
from reg_automata import DFA
from antlr4 import RecognitionException # type: ignore
import sys


def transformation(solution: str, solution_type: str) -> DFA:
    if solution_type == "DFA":
        parser = Parser()
        return parser.str_to_dfa(solution)
    elif solution_type == "NFA":
        parser = Parser()
        nfa = parser.str_to_nfa(solution)
        return nfa.determinize()
    #elif solution_type == "EFA":
    #    parser = Parser()
    #    efa = parser.str_to_efa(solution)
    #    return efa.eliminate_epsilon.determinize()

def main():
    with open(sys.argv[1]) as student_file:
        student_solution = student_file.read()

    for argument in sys.argv:
        if argument[:2] == "-o":
            teacher_solution = argument[2:]

    task, teacher_solution = teacher_solution.split(":", 1)
    student_type, teacher_type = task.split("-", 1)
    student_dfa = transformation(student_solution, student_type)
    teacher_dfa = transformation(teacher_solution, teacher_type[:3])

    try:
        parser = Parser()
        result = student_dfa.is_equivalent(teacher_dfa)
        if result:
            exit(0)
        else:
            student_word, teacher_word = result.left_counterexample, result.right_counterexample
            print("Hláška, že to není správně.")
            print("Příklad slova, které je ve studentově řešení a není v zadaném jazyce: ", student_word)
            print("Příklad slova, které chybí ve studentově řešení a je v zadaném jazyce: ", teacher_word)
            exit(1)

    except RecognitionException as ex:
        print(ex)

main()